
open Ast

let rec height = function
  | Leaf -> 0
  | Node xs -> 1 + (List.fold_left (fun ht x -> max ht (height x)) 0 xs)

let () =
  let buf = Lexing.from_string Sys.argv.(1) in
  try
    let ast = Parser.top Lexer.lex buf in
    Printf.printf "Height: %d\n" (height ast)
  with Parser.Error ->
    print_endline "Parse error"
;;
