%{
  (* Header: everything betweeen %{ and %} is exported directly to the
     beginning of the generated .ml file *)

%}

/* Begin grammatical specification */

/* Typically, we start by declaring tokens.  menhir uses the tokens to
   automatically generate a token datatype */
%token LPAREN
%token RPAREN
%token EOF


/* Declare "program" as the starting nonterminal of the grammar */
%start top

/* Type annotations for program */
%type <Ast.ast> top

%% /* Productions go here, after %% */

/* Grammar:
   <top> ::= <balanced_list> EOF
   <balanced_list> ::= <balanced><balanced_list>
                    |  <balanced>
   <balanced> ::= ( <balanced_list> )
                | ( )
*/

top:
  | xs=balanced_list EOF  { Ast.Node xs }

balanced_list:
  | x=balanced xs=balanced_list { x::xs }
  | x=balanced { [x] }

balanced:
  | LPAREN xs=balanced_list RPAREN { Ast.Node xs }
  | LPAREN RPAREN { Ast.Leaf }
